Actually add that file

This commit is contained in:
Salt 2020-05-06 02:01:30 -05:00
parent f5acd6014d
commit 4c54833b7e

View File

@ -0,0 +1,57 @@
#! /bin/bash
#
# nextcloud.sh
# Backup script for Nextcloud. Meant to be sourced by our main backup script
# Copyright (C) 2020 Vintage Salt <rehashedsalt@cock.li>
#
# Distributed under terms of the MIT license.
#
set -e
export OUTDIR="$BACKUPSDIR/{{ nextcloud_url }}"
retention=7 # 7-day retention period
# Sanity checks
if [ -z "$BACKUPSDIR" ]; then
log "BACKUPSDIR was undefined. Run the main backup script instead of this one."
return 1
fi
if ! [ -d "$OUTDIR" ]; then
if ! mkdir "$OUTDIR"; then
log "Unable to find or create output directory: $OUTDIR"
return 2
fi
fi
# Enforce permissions on our output directory since the git user will need them
chown root.git "$OUTDIR"
chmod 770 "$OUTDIR"
# Purge oldest backup if we need to
currentbackupcount="$(ls -1 "$OUTDIR" | wc -l)"
if (( currentbackupcount >= retention )); then
lastbackup="$(find "$OUTDIR" -name \*.zip 2>/dev/null | sort | head -n 1)"
if [ -f "$lastbackup" ]; then
log "Removing old backup: $lastbackup"
rm "$lastbackup"
fi
fi
# WE MAKE BACKUP NOW SERGEI
if cd "{{ nextcloud_webroot }}"; then
log "Enabling maintenance mode"
sudo -u www-data ./oc maintenance:mode --on
trap 'sudo -u www-data ./occ maintenance:mode --off' EXIT
date="$(date -Iseconds)"
log "Creating data backup"
tar czf "$OUTDIR/$date-data.tar.gz" "/var/nextcloud"
log "Creating webroot backup"
tar czf "$OUTDIR/$date-webroot.tar.gz" "{{ nextcloud_webroot }}"
log "Creating DB backup"
mysqldump nextcloud --single-transaction | gzip > "$OUTDIR/$date-db.sql.gz"
log "Unsetting maintenance mode"
sudo -u www-data ./occ maintenance:mode --off
else
log "Could not change directory: $OUTDIR"
return 3
fi